/*  Semestral work,
 *  Walking trough the town.
 *  Copyright (c) 2002, 2003 Michal Conos
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


/* This class is used for AC object loading */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#ifdef WIN32
#include <windows.h>
#else
#include <unistd.h>
#endif

#include <math.h>
#include <plib/ssg.h>
#include <GL/glut.h>

#ifndef PI
# define PI 3.141592653589
#endif

#include "acobj.h"

ACObject::ACObject( ssgRoot *scene, char *obj_filename ) 
{
	ac = new ssgTransform ;
	ssgEntity *ac_obj = ssgLoadAC ( obj_filename );
	ac    -> addKid ( ac_obj  ) ;
	ssgFlatten      ( ac_obj  ) ;
	ssgStripify     ( ac    ) ;
	scene -> addKid ( ac   ) ;
	timer=new Timer(30);
}

ACObject::~ACObject() { }

void ACObject::set_position( double x, double y, double z, double a ) 
{
  sgSetCoord ( &ac_obj_pos, x,  y, z, -90-a, -0.0f, 0.0f ) ;
  ac -> setTransform( &ac_obj_pos );
  _x=x; _y=y; _z=z;	_a1=a;
}

void ACObject::set_position( double x, double y, double z ) 
{
	set_position( x, y, z, -90 );
}


void ACObject::get_position( double *x, double *y, double *z )
{
	*x=_x; *y=_y; *z=_z;
}

void ACObject::update_position( double vx, double vy, double vz )
{
	double dt=timer->get_game_time_delta();
	double k =timer->get_speedup();
	double d_sx=vx*dt*k;
	double d_sy=vy*dt*k;
	double d_sz=vz*dt*k;
	double ox,oy,oz;
	get_position( &ox, &oy, &oz );
	ox+=d_sx;
	oy+=d_sy;
	oz+=d_sz;
	set_position( ox, oy, oz );
}
	







