
#include <stdio.h>
#include <stdlib.h>
#include "car.h"
#include <sys/time.h>

Car::Car(double w, double mv, double Faccel, double Fdecel, double P)
{
	m=w;
	C=.35;
	max_v=mv;
	max_P=P;	
	S=2.24;
	t=v=a=0;
	Fa=Faccel;
	Fd=Fdecel;
	gettimeofday(&timer,NULL);
}

Car::~Car() {}

double Car::get_accel( double Fp )
{
	double Ft=0.5*C*S*ro*v*v;
	double F=Fp-Ft; /* resulting power */

	a=F/m;

	return a;
}


static double get_dt(struct timeval t1, struct timeval t2)
{
	long sec1=t1.tv_sec;	
	long sec2=t2.tv_sec;	
	long usec1=t1.tv_usec;	
	long usec2=t2.tv_usec;	

	long dt=sec1-sec2;
	long dtu=usec1-usec2;
	if( dtu<0 ) { dtu+=1000000L; dt--; }

	return dt+dtu/1e6;
}

double Car::accelerate()
{
	struct timeval tv;	
	gettimeofday(&tv, NULL);
	double dt=get_dt( tv, timer );
	timer=tv;
	t+=dt;
	a=get_accel(Fa);
	v+=a*dt;
	if( v>max_v/3.6 ) v=max_v/3.6;
	ds=0.5*a*dt;
	return ds;
}

double Car::deccelerate()
{
	struct timeval tv;	
	gettimeofday(&tv, NULL);
	double dt=get_dt( tv, timer );
	timer=tv;
	t+=dt;
	a=get_accel(Fd);
	v+=a*dt;
	ds=0.5*a*dt;
	return ds;
}
double Car::get_velocity()
{
	return v;
}

double Car::get_time()
{
	return t;
}
