#ifndef _LIGHTS_H_
#define _LIGHTS_H_ 1

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>
#include "acobj.h"

typedef enum {
	GO, STOP, NIGHT_TRAFFIC
} lights_mode_t;

#define DEFAULT_DELAY 5       /* sec */
#define DEFAULT_NIGHT_DELAY 1 /* sec */

class Lights {
	public:
	Lights(ssgRoot *scene, double x, double y, double z, double a);
	~Lights();

	void red_light();
	void orange_light();
	void green_light();
	void redorange_light();
	void no_light();
	
	void set_state( lights_mode_t mode );
	void render();
	void set_position(double x, double y, double z );
	void set_position(double x, double y, double z, double a );

	private:
	void _night_traffic();
	void _green2red();
	void _red2green();

	lights_mode_t act_mode, sw_mode;
	int changing_light;
	ACObject *_red_light, *_green_light, *_orange_light, *_redorange_light, *_no_light;
	time_t timer;
	int flipflop;

	double lx,ly,lz,la;
	int id;

};

#endif /* _LIGHTS_H_ */
