/*  Semestral work,
 *  Walking trough the town.
 *  Copyright (c) 2002, 2003 Michal Conos
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


// TODO::
// camaro must be a class
// camera should be a class
// world should accumulate somethong else than ACObject* to be able to determine object type
// better drawing engine - increase FPS

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#ifdef WIN32
#include <windows.h>
#else
#include <unistd.h>
#endif

#include <math.h>
#include <plib/ssg.h>
#include <plib/ssgAux.h>
#include <plib/ssgaSky.h>
#include <GL/glut.h>

#ifndef PI
# define PI 3.141592653589
#endif


#include "timer.h"
#include "acobj.h"
#include "lights.h"
#include "world.h"
#include "sky.h"
#include "camaro.h"

static int fullscreen=0;


Timer *timer=NULL;
Camaro *chevy_camaro=NULL;
ssgRoot      *scene    = NULL ;
ACObject *camaro;
Lights * semaphore[12];
lights_mode_t actual_state=GO;
World *world;
static MySky *sky=NULL ;

/*
  Something to make some interesting motion
*/

static double ca1=0, ca2=0, cam_x=0 ,cam_y=100,cam_z=200;
static int ascend=0;
static int descend=0;

double r=0;

void update_motion ()
{
	static int frameno=0;
	static double tt=timer->get_game_time();

	
	frameno++;
	double t_now=timer->get_game_time();
	if( t_now-tt >= 1 ) {
		printf("FPS:%.2f [%.3f %.3f %.3f] vel=%.3f m/s\n", frameno/(t_now-tt), cam_x, cam_y, cam_z, chevy_camaro->get_velocity());
		frameno=0;
		tt=t_now;
	}

	if(ascend) cam_z--;
	if(descend) cam_z++;

	
	double a1=ca1*PI/180;
	double a2=ca2*PI/180;

/*
	double vx=r*cos(a1)*cos(a2);
	double vy=r*sin(a1)*cos(a2);
	double vz=r*sin(a2);
*/
	double vx=r*cos(a1); double vy=r*sin(a1); double vz=0;
	
	double dt=timer->get_game_time_delta();
	double d_sx=vx*dt*30;
	double d_sy=vy*dt*30;
	double d_sz=vz*dt*30;
	
	cam_x-=d_sy; cam_y+=d_sx;

  sgCoord campos ;
  campos.xyz[0]=cam_x;
  campos.xyz[1]=cam_y;
  campos.xyz[2]=cam_z;

  double e=fmod(t_now, 360);
  sky->set_sun_dec(e);
//  sky->set_moon_dec((elapsed_time+180)%360);
  sky->update_sky( campos );	


  semaphore[0]->render();
  semaphore[1]->render();
  semaphore[2]->render();
  semaphore[3]->render();
  semaphore[4]->render();
  semaphore[5]->render();
  semaphore[6]->render();
  semaphore[7]->render();
  camaro->set_position( cam_x, cam_y, -100, 90-ca1 ); 
  static double s=0;
  s+=100*chevy_camaro->accelerate();
  chevy_camaro->set_position( -200, 500+s, -100, 90 ); 
//  ssgGetLight ( 1 ) -> setPosition ( cam_x+120*sin((-ca1)*PI/180), cam_y+120*cos((-ca1)*PI/180), -95 ) ;
//  ssgGetLight ( 1 ) -> setSpotDirection ( cam_x+170*sin((ca1)*PI/180), cam_y+170*cos((ca1)*PI/180), -100 ) ;
//  ssgGetLight ( 1 ) -> setSpotAttenuation( 0, 0.02, 0 );
//  ssgGetLight ( 1 ) -> setSpotlight( 1 );
//  ssgGetLight ( 1 ) -> setSpotDiffusion( 0.2, 70 );
//  ssgGetLight( 1 ) -> setColour( GL_AMBIENT, car_ambient );
//  ssgGetLight( 1 ) -> setColour( GL_DIFFUSE, car_diffuse );
//  ssgGetLight( 1 ) -> setColour( GL_SPECULAR, car_specular );
//  ssgGetLight( 1) -> on();
//

  sgSetCoord ( & campos, cam_x, cam_y, cam_z, ca1, ca2, 0 ) ;
  ssgSetCamera ( & campos ) ;

}



/*
  The GLUT window reshape event
*/

void reshape ( int w, int h )
{
  glViewport ( 0, 0, w, h ) ;
}

#define STEP_Y 1

/*
  The GLUT special key event
*/

void special ( int key, int a,  int b )
{
}

void mouse( int b, int up, int x, int y )
{

	switch (b) {
	case GLUT_LEFT_BUTTON:   
		if(!up) descend=1;
		else    descend=0;
		break;
	case GLUT_MIDDLE_BUTTON:  ; break;
	case GLUT_RIGHT_BUTTON:  
		if(!up) ascend=1;
		else    ascend=0;
		break;
	}

	

}

void mouse_move( int x, int y )
{
	static int ox=x;
	static int oy=y;
	static int c=0;
	c++;

	//printf("ox=%d oy=%d -> x=%d y=%d\n", ox,oy,x,y);

	ca1-=(x-ox);
	ca2-=(y-oy);

	ox=x;
	oy=y;
	if( c==10 ) {
		c=0;
		glutWarpPointer(320,200);
		ox=320;oy=200;
	}
}

/*
  The GLUT keyboard event
*/

void keyboard ( unsigned char key, int a,  int b )
{
  switch ( key ) {
    case 'q':
      exit ( 0 ) ;
	case 'r':
	  	semaphore[0]->set_state( STOP );
	  	semaphore[1]->set_state( STOP );
	  	semaphore[2]->set_state( STOP );
	  	semaphore[3]->set_state( STOP );
	  	semaphore[4]->set_state( STOP );
	  	semaphore[5]->set_state( STOP );
	  	semaphore[6]->set_state( STOP );
	  	semaphore[7]->set_state( STOP );
		break;	
	case 'g':
	  	semaphore[0]->set_state( GO );
	  	semaphore[1]->set_state( GO );
	  	semaphore[2]->set_state( GO );
	  	semaphore[3]->set_state( GO );
	  	semaphore[4]->set_state( GO );
	  	semaphore[5]->set_state( GO );
	  	semaphore[6]->set_state( GO );
	  	semaphore[7]->set_state( GO );
		break;
	case 'n':	
	  	semaphore[0]->set_state( NIGHT_TRAFFIC );
	  	semaphore[1]->set_state( NIGHT_TRAFFIC );
	  	semaphore[2]->set_state( NIGHT_TRAFFIC );
	  	semaphore[3]->set_state( NIGHT_TRAFFIC );
	  	semaphore[4]->set_state( NIGHT_TRAFFIC );
	  	semaphore[5]->set_state( NIGHT_TRAFFIC );
	  	semaphore[6]->set_state( NIGHT_TRAFFIC );
	  	semaphore[7]->set_state( NIGHT_TRAFFIC );
		break;
	case 'a':
		r-=0.2;
		if(r<-10)r=-10;
		break;
	case 'z':
		r+=0.1;
		if(r>2)r=2;
		break;
  }
}



/*
  The GLUT redraw event
*/

void redraw ()
{
 //glClear(GL_COLOR_BUFFER_BIT |  GL_DEPTH_BUFFER_BIT);
 glClear( GL_DEPTH_BUFFER_BIT);

  update_motion () ;

/*
  glLightfv(GL_LIGHT2, GL_AMBIENT, lc_amb);
  glLightfv(GL_LIGHT2, GL_DIFFUSE, lc_diff);
  glLightfv(GL_LIGHT2, GL_SPECULAR, lc_spec);
  glLightfv(GL_LIGHT2, GL_POSITION, lc_pos);
  glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, lc_dir);
  glLightf(GL_LIGHT2, GL_SPOT_CUTOFF, 45);
  glLightf(GL_LIGHT2, GL_SPOT_EXPONENT, 0.5);

  if ( lighton ) glEnable(GL_LIGHT2);
*/

  sky -> preDraw  ( );
 ssgCullAndDraw ( scene ) ;
 sky -> postDraw ( cam_z ); /* altitude */

  glutPostRedisplay () ;
  glutSwapBuffers () ;

}



void init_graphics (int argc, char *argv[])
{
  char *fake_argv[3] ;
  fake_argv[0] = "ZPG" ;
  fake_argv[1] = "Prochazka mestem" ;
  fake_argv[2] = NULL ;

  /*
    Initialise GLUT
  */

  //glutInit               ( &fake_argc, fake_argv ) ;
  glutInit               ( &argc, argv ) ;
  glutInitDisplayMode    ( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH ) ;

#define WININIT glutInitWindowPosition ( 0, 0 ) ; \
    glutInitWindowSize     ( 640, 480 ) ; \
    glutCreateWindow       ( fake_argv[1] ) ;

  if ( !fullscreen ) {
    WININIT
  } else {
    glutGameModeString("640x480:16");
    if ( glutGameModeGet(GLUT_GAME_MODE_POSSIBLE) ) {
      glutEnterGameMode();
    } else {
//fallback
      WININIT;
    }
  }
  glutDisplayFunc        ( redraw   ) ;
  glutReshapeFunc        ( reshape  ) ;
  glutKeyboardFunc       ( keyboard ) ;
  glutSpecialFunc        ( special ) ;
  glutPassiveMotionFunc  ( mouse_move );
  glutMouseFunc          ( mouse   );
 
  /*
    Initialise SSG
  */

  ssgInit () ;

  /*
    Some basic OpenGL setup
  */

//  glClearColor ( 0.2f, 0.7f, 1.0f, 1.0f ) ;
  glEnable ( GL_DEPTH_TEST ) ;

  glFogi( GL_FOG_MODE, GL_EXP2 );

  /*
    Set up the viewing parameters
  */

  ssgSetFOV     ( 60.0f, 0.0f ) ;
  ssgSetNearFar ( 1, 200000 ) ; /* nb. skydome is scalable ... so far can be reduced */

}


/*
  Load a simple database
*/

void load_database ()
{
  /*
    Set up the path to the data files
  */

 ssgModelPath   ( "data" ) ;
 ssgTexturePath ( "data" ) ;


  /*
     Create objects 
  */
 	timer  = new Timer;
  scene    = new ssgRoot      ;
  
  camaro = new ACObject( scene, "camaro.ac" );
  chevy_camaro = new Camaro( scene );
  ACObject *skybox = new ACObject( scene, "box.ac" );
  ACObject *clouds = new ACObject( scene, "clouds.ac" );
//  skybox ->set_position(0,0,0,0);
  semaphore[0] = new Lights( scene, 0, 0, 0, 0 );
  semaphore[1] = new Lights( scene, 0, 0, 0, 0 );
  semaphore[2] = new Lights( scene, 0, 0, 0, 0 );
  semaphore[3] = new Lights( scene, 0, 0, 0, 0 );
  semaphore[4] = new Lights( scene, 0, 0, 0, 0 );
  semaphore[5] = new Lights( scene, 0, 0, 0, 0 );
  semaphore[6] = new Lights( scene, 0, 0, 0, 0 );
  semaphore[7] = new Lights( scene, 0, 0, 0, 0 );
  world    = new World( scene );
  semaphore[0]->set_position( -20, 1100, -100, -90 );
  semaphore[1]->set_position( -20, 500, -100, -90 );
  semaphore[2]->set_position( -20, 1500, -100, -90 );
  semaphore[3]->set_position( -20, 1700, -100, -90 );
  semaphore[4]->set_position( -20, 1800, -100, -90 );
  semaphore[5]->set_position( -20, 2000, -100, -90 );
  semaphore[6]->set_position( -20, 2400, -100, -90 );
  semaphore[7]->set_position( -20, 3000, -100, -90 );

  sky       =  new MySky();
 
}



/*
  The works.
*/

int main ( int argc, char *argv[] )
{
  init_graphics (argc, argv) ;
  load_database () ;
  glutMainLoop  () ;
  return 0 ;
}



