#ifndef _MYSKY_H_
#define _MYSKY_H_ 1

#include <plib/ssg.h>
#include <plib/ssgAux.h>
#include <plib/ssgaSky.h>
#include "timer.h"

class MySky {
	public:
		MySky();
		~MySky();

		void update_sky(sgCoord campos);
		void preDraw();
		void postDraw(double z);

		void set_sun_dec( double e );
		void set_moon_dec( double e );
	private:
		#define MAX_BODIES  2
		 ssgaCelestialBody  *bodies[MAX_BODIES] ;
		 sgVec4 base_ambient   ;
		 sgVec4 base_diffuse   ;
		 sgVec4 base_specular  ;
		Timer *timer;


sgVec4 black              ;

sgVec4 scene_ambient ;
sgVec4 scene_diffuse ;
sgVec4 scene_specular ;

sgdVec3            *star_data ;
int                 nstars  ;

	sgVec4 cloud_color ;
	sgVec4 sky_color    ;
	sgVec4 base_sky_color    ;
	sgVec4 fog_color    ;
	sgVec4 base_fog_color    ;

	ssgaSky *sky;
	ssgaCloudLayer * clouds;
};

#endif /* _MYSKY_H_ */
